function elbasScenarios( elbScen, bmScen, hours)

%Define number of each demand profile for each scenario based on historical
%occurenses. 
nbh = elbScen * 0.3; 
nbm = elbScen * 0.6; 
nbs = elbScen * 0.1;
nsh = elbScen * 0.5; 
nsm = elbScen * 0.4; 
nss = elbScen * 0.1;

%Define the slope for each demand profile
abh = 0.05353;
abm = 0.035900;
abl = 0.035150;
ash = -0.04567;
asm = -0.040079;
asl = -0.056683;

%Input the residuals from file

cd 'C:\xpressmp\matlab'
resBH = xlsread('ElbasRegression2.xlsx', 'BuyH', 'I2:I1840'); 
resBM = xlsread('ElbasRegression2.xlsx', 'BuyM', 'I2:I3394'); 
resBS = xlsread('ElbasRegression2.xlsx', 'BuyH', 'I2:I449'); 
resSH = xlsread('ElbasRegression2.xlsx', 'SellH', 'I2:I1299'); 
resSM = xlsread('ElbasRegression2.xlsx', 'SellM', 'I2:I1112'); 
resSS = xlsread('ElbasRegression2.xlsx', 'SellH', 'I2:I342'); 

cd 'C:\xpressmp\matlab'

filename = fopen('ElbasSlopeBuy.txt', 'wt'); 
fprintf(filename, 'ElbasSlopeBuy: [\n'); 
for i = 1:bmScen
    for h = 1:nbh
        for t = 1:hours
            fprintf(filename, '%f\t', abh); 
        end
        fprintf(filename, '\n'); 
    end
end
for i = 1:bmScen
    for m = 1:nbm
        for t = 1:hours
            fprintf(filename, '%f\t', abm); 
        end
        fprintf(filename, '\n'); 
    end
end
for i = 1:bmScen
    for l = 1:nbs
        for t = 1:hours
            fprintf(filename, '%f\t', abl); 
        end
        fprintf(filename, '\n'); 
    end
end
fprintf(filename, ']\n'); 
fclose(filename); 

filename = fopen('ElbasSlopeSell.txt', 'wt'); 
fprintf(filename, 'ElbasSlopeSell: [\n'); 

for i = 1:bmScen
    for h = 1:nsh
        for t = 1:hours
            fprintf(filename, '%d\t', ash); 
        end
        fprintf(filename, '\n');
    end
end
for i = 1:bmScen
    for m = 1:nsm
        for t = 1:hours
            fprintf(filename, '%d\t', asm); 
        end
        fprintf(filename, '\n'); 
    end
end
for i = 1:bmScen
    for l = 1:nss
        for t = 1:hours
            fprintf(filename, '%d\t', asl); 
        end
        fprintf(filename, '\n'); 
    end
end

fprintf(filename, ']\n'); 
fclose(filename); 

filename = fopen('ElbasInterceptBuy.txt', 'wt'); 
fprintf(filename, 'ElbasInterceptBuy: [\n'); 

for j = 1:bmScen
    for i = 1:nbh
        for t = 1:hours
            tempRndErrBH = floor(randi(length(resBH)));  
            rndErrBH = resBH(tempRndErrBH); 
            fprintf(filename, '%f\t', -12.72500 + rndErrBH); 
        end
        fprintf(filename, '\n');
    end
end
for j = 1:bmScen
    for i = 1:nbm
        for t = 1:hours
            tempRndErrBM = floor(randi(length(resBM)));  
            rndErrBM = resBM(tempRndErrBM); 
            fprintf(filename, '%f\t', -8.048293 + rndErrBM); 
        end
        fprintf(filename, '\n'); 
    end
end
for j = 1:bmScen
    for i = 1:nbs
        for t = 1:hours
            tempRndErrBS = floor(randi(length(resBS)));  
            rndErrBS = resBH(tempRndErrBS); 
            fprintf(filename, '%f\t', -1.761772 + rndErrBS); 
        end
        fprintf(filename, '\n'); 
    end
end

fprintf(filename, ']\n'); 
fclose(filename); 

filename = fopen('ElbasInterceptSell.txt', 'wt'); 
fprintf(filename, 'ElbasInterceptSell: [\n'); 
for j = 1:bmScen
    for i = 1:nsh
        for t = 1:hours
            tempRndErrSH = floor(randi(length(resSH))); 
            rndErrSH = resSH(tempRndErrSH); 
            fprintf(filename, '%f\t', 10.23344 + rndErrSH); 
        end
        fprintf(filename, '\n'); 
    end
end
for j = 1:bmScen
    for i = 1:nsm
        for t = 1:hours
            tempRndErrSM = floor(randi(length(resSM)));  
            rndErrSM = resSM(tempRndErrSM); 
            fprintf(filename, '%f\t', 5.984746 + rndErrSM); 
        end
        fprintf(filename, '\n'); 
    end
end
for j = 1:bmScen
    for i = 1:nss
        for t = 1:hours
            tempRndErrSS = floor(randi(length(resSS)));  
            rndErrSS = resSH(tempRndErrSS); 
            fprintf(filename, '%f\t', 0.728433 + rndErrSS); 
        end
        fprintf(filename, '\n'); 
    end
end

fprintf(filename, ']\n'); 
fclose(filename); 


%Define the segment probabilities, delta, for each scenario. 
dBH = xlsread('ElbasRegression2-2.xlsx', 'Total', 'W2:W12');  
dBM = xlsread('ElbasRegression2-2.xlsx', 'Total', 'W13:W23'); 
dBS = xlsread('ElbasRegression2-2.xlsx', 'Total', 'W24:W34'); 
dSH = xlsread('ElbasRegression2-2.xlsx', 'Total', 'AA2:AA12');  
dSM = xlsread('ElbasRegression2-2.xlsx', 'Total', 'AA13:AA23'); 
dSS = xlsread('ElbasRegression2-2.xlsx', 'Total', 'AA24:AA34'); 

filename = fopen('SegmentProbabilities.txt', 'wt'); 
fprintf(filename, 'SegmentProbabilityBuy: [\n'); 
for j = 1:bmScen
    for i = 1:nbh
        for s = 1:11
            fprintf(filename, '%f\t', dBH(s)); 
        end
        fprintf(filename, '\n'); 
    end
end
for j = 1:bmScen
    for i = 1:nbm
        for s = 1:11
            fprintf(filename, '%f\t', dBM(s)); 
        end
        fprintf(filename, '\n'); 
    end
end
for j = 1:bmScen
    for i = 1:nbs
        for s = 1:11
            fprintf(filename, '%f\t', dBS(s)); 
        end
        fprintf(filename, '\n');
    end
end
fprintf(filename, ']\n'); 

fprintf(filename, 'SegmentProbabilitySell: [\n'); 
for j = 1:bmScen
    for i = 1:nsh
        for s = 1:11
            fprintf(filename, '%f\t', dSH(s)); 
        end
        fprintf(filename, '\n'); 
    end
end
for j = 1:bmScen
    for i = 1:nsm
        for s = 1:11
            fprintf(filename, '%f\t', dSM(s)); 
        end
        fprintf(filename, '\n'); 
    end
end
for j = 1:bmScen
    for i = 1:nss
        for s = 1:11
            fprintf(filename, '%f\t', dSS(s)); 
        end
        fprintf(filename, '\n'); 
    end
end
fprintf(filename, ']\n'); 

fclose(filename); 
end

