function [BMPremium] = forecastBMMaster(probMatrix, nScenarios, hours, b2, b3, e2, e3, startHour, forecast)   

mu2 = 1.146681844; 
mu3 = 1.419532271; 
sigma2 = 0.091121112; 
sigma3 = 0.122669065; 
c1 = -0.014802;
c2 = -0.0002554; 
phi11 = 0.953229; 
phi21 = 1.8762145; 
phi22 = -0.8776502; 
theta11 = 0.023579; 
theta12 = 0.040513; 
theta21 = -1.0092936; 
theta22 = 0.0220693;    
theta23 = 0.0188323; 
upMax = 400; 
downMax = 200; 

filename = fopen('BMscenario.txt', 'wt');

% tempRnd = randi(100);
% iniIntervals = genInterval(iniProbs)*100;
% iniState = returnState(tempRnd,iniIntervals); 
%     
stateVec = zeros(1, (hours * nScenarios) + 1);
BMPremium = zeros(1, (hours * nScenarios) + 1); 
 
% stateVec(1) = iniState; 

%Because we need to forecast one hour before the actual hour we need
newStart = startHour - 1; 

stateVec(1) = randi(3); 
BMPremium(1) = 0; 
count = 1;
premium = 0;  
scenProb = 1/nScenarios;

%Format the output file to fit ScenRed
fprintf(filename, 'TYPE FAN\n'); 
fprintf(filename, 'TIME %d\n', forecast + 1); 
fprintf(filename, 'SCEN %d\n', nScenarios);
fprintf(filename, 'RANDOM %d\n', 1);
fprintf(filename, 'DATA\n');

for i = 1:nScenarios
    fprintf(filename,'%f\n', scenProb);
    fprintf(filename, '%f\n', BMPremium(1)); 
    
    for t = 1:hours
        
        count = count + 1;  
        
        hour = t + newStart - 1; 
        
        %Set the proper initialization of reading from the probability
        %matrix for a given hour
        if mod(hour,24) == 0
            set = 24;  
        else 
            set = hour - 24 * floor(hour/24);
        end
        
        temp = set * 3 - 2; 
            
        tempProb = probMatrix(temp:temp + 2, 1:3); 
        
        %Increment the index for each new hour
        j = newStart + t - 1; 
        
        %Generate the transition state
        interval = genInterval(tempProb(stateVec((count) - 1),:))*100;
        tempRnd=randi(100);
        state = returnState( tempRnd, interval );
        
        stateVec(count) = state; 
        
        tempRndErr2 = floor(randi(length(e2))); 
        tempRndErr3 = floor(randi(length(e3))); 
        
        rndErr2 = e2(tempRndErr2); 
        rndErr3 = e3(tempRndErr3); 
       
        %Calculate the premiums and update the forecasting array
        lnBMUp = phi11 * b2(j - 1) + theta11 * e2(j - 1) + theta12 * e2(j - 2) + c1;
               
        lnBMDown = phi21 * b3(j - 1) + phi22 * b3(j - 2) + theta21 * e3(j - 1) + theta22 * e3(j - 2) + theta23 * e2(j - 3) + c2; 
               
        for m = 2:3
           if m == state && m == 2
              premium = exp(lnBMUp + mu2 + rndErr2 + sigma2/2); 
              b2(j) = lnBMUp; 
              b3(j) = b2(j - 1); 
              if premium > upMax
                  premium = upMax; 
              end
           elseif m == state && m == 3 
              premium = - exp(lnBMDown + mu3 + rndErr3 + sigma3/2); 
              b2(j) = b2(j - 1);
              b3(j) = lnBMDown; 
              if premium < - downMax
                  premium = - downMax; 
              end        
           elseif state ~= 2 && state ~= 3 
              premium = 0; 
              b2(j) = b2(j - 1);
              b3(j) = b3(j - 1); 
           end
            
        BMPremium(count) = premium;
        end
        
        if isnan(BMPremium(count))
           BMPremium(count) = 0; 
        end                     
        
        if t > (hours - forecast)
            fprintf(filename,'%f\n',BMPremium(count));
        end
    end
    fprintf(filename, '\n'); 
end
fprintf(filename, 'END');
fclose(filename);

% figure(1)
% hold off
% grid on
% plot(BMPremium);

end


