import linecache

#Startline is 9 for reading and 11 for reduced result
#Random is the integer number of the random variable (i.e. starts at 1, not at 0)
def parsescenarios(filename,randomnumber,outputfilename,startlinenumber=11,blanksbetween=1):
	fin = open(filename)
	timesteps = 0
	scenarios = 0
	random = 0
	for line in fin:
		atoms = line.split()
		if len(atoms) >0:
			if atoms[0] == 'TIME':
				timesteps = int(atoms[1])
				#print("timesteps: " + str(timesteps) + "\n")
			if atoms[0] == 'SCEN':
				scenarios = int(atoms[1])
			if atoms[0] == 'RANDOM':
				random = int(atoms[1])
	resultlist = (timesteps,scenarios,random)
	if randomnumber > random:
		print 'The scenario you asked for is out of range! \n'
	fout = open(outputfilename,'a')
	for s in range(scenarios):
		startline = startlinenumber + s*(timesteps+1+blanksbetween)
		scenariolist = []
		for t in range(timesteps):
			linenumber = startline + t
			scenariodata = linecache.getline(filename,linenumber)
			splitline = scenariodata.split()
			#print(splitline)
			observation = splitline[(randomnumber-1)]
			scenariolist.append(observation)
			fout.write(observation + '\t')
		#print( str(len(scenariolist)) + "\n")
		fout.write('\n')
	fin.close()
	fout.close()
	return scenariolist

def find_probabilities(filename,outputfilename,startlinenumber=11,blanksbetween=1):
	fin = open(filename)
	timesteps = 0
	scenarios = 0
	random = 0
	for line in fin:
		atoms = line.split()
		if len(atoms) >0:
			if atoms[0] == 'TIME':
				timesteps = int(atoms[1])
				#print("timesteps: " + str(timesteps) + "\n")
			if atoms[0] == 'SCEN':
				scenarios = int(atoms[1])
			if atoms[0] == 'RANDOM':
				random = int(atoms[1])
	resultlist = (timesteps,scenarios,random)
	fout = open(outputfilename,'a')
	probabilitylist = []
	for s in range(scenarios):
		startline = startlinenumber + s*(timesteps+1+blanksbetween)
		probability = linecache.getline(filename,(startline-1))
		probabilitylist.append(probability)
	#print(probabilitylist)
	for p in probabilitylist:
		fout.write(p)
	fin.close()
	fout.close()
	return probabilitylist	
	
#This function takes a treefile (the standard format from POM and Scenred) and makes a dict of a treenodefile where the nodenumbers are the keys and the #value is a list containing the predecessor and the values 
#The first (dummy) node is numbered as 1
def makenodedict(nodeinputfilename):
	print 'Hello world!'
	startreadline=0
	fin = open(nodeinputfilename,'r')
	numberoflines = len(fin.readlines())
	lines = fin.readlines()
	num = 0
	for line in fin:
		print 'something'
		num = num + 1
		if 'PRED' in line:
			startreadline = num
			print startreadline
		else:
			print "I could not find the word PRED in this file!"
			break
	nodedict = {}
	counter = 0
	for line in lines[startreadline:numberoflines]:
		counter = counter +1
		print counter
		inputline = line.split()
		nodedict[counter] = inputline
	#print nodedict
	fin.close()
	return nodedict
	
def testfunction(file):
	fin = open(file,'r')
	lines = fin.readlines()
	print('PRED' in lines)
	return
		
#testfunction('testdata.txt')
#makenodedict('testdata.txt')	
#parsescenarios('row.dat',1,'BMpricescenarios.txt',11,1)
#parsescenarios('row.dat',2,'BMvolumescenarios.txt',11,1)
parsescenarios('row.dat',1,'scenariosParseBMUpVol.txt',11,1)
#parsescenarios('scaled_scenariofan.txt',3,'originalinput_balancingprice_premium.txt',8,2)
find_probabilities('row.dat','probabilityBMUpVol.txt',11,1)
