function volumeUpGeneration (up, hours)

filename = fopen('bmUpVolume.txt', 'wt'); 

%Fit distributions to historical data
c = fitdist(up, 'GeneralizedExtremeValue'); 
nScenarios = 3000; 
scenProb = 1/nScenarios; 
%Create distributions from the characteristics
pdUp = makedist('GeneralizedExtremeValue', 'k', c.k, 'sigma', c.sigma, 'mu', c.mu); 

fprintf(filename, 'TYPE FAN\n'); 
fprintf(filename, 'TIME %d\n', hours + 1); 
fprintf(filename, 'SCEN %d\n', nScenarios);
fprintf(filename, 'RANDOM %d\n', 1);
fprintf(filename, 'DATA\n');

for i = 1:nScenarios
    fprintf(filename,'%f\n', scenProb);
    fprintf(filename, '%f\n', 0);  
    
    for t = 1:hours
        fprintf(filename,'%f\n',0.1*random(pdUp));
    end
    fprintf(filename, '\n');    
end

fprintf(filename, 'END');
fclose(filename);

end
